| Home | Libraries | People | FAQ | More

## Macro BOOST_CONTRACT_BASES_TYPEDEF

BOOST_CONTRACT_BASES_TYPEDEF — Define the name of the base type `typedef` (`base_types` by default).

## Synopsis

    // In header: <boost/contract/core/config.hpp>

    BOOST_CONTRACT_BASES_TYPEDEF

## Description

This macro expands to the name of the `typedef` that lists the base classes for subcontracting via `BOOST_CONTRACT_BASE_TYPES`:

    class u
        #define BASES public b, private w
        : BASES
    {
        friend class boost::contract:access;

        typedef BOOST_CONTRACT_BASE_TYPES(BASES) BOOST_CONTRACT_TYPEDEF;
        #undef BASES

        ...
    };

When used this way, users can redefine this macro if the `typedef` must have a name different from `base_types` (because of name clashes in user code, etc.).

See Also: Base Classes